local defined = {
  standard_bs = {
    {
      name = "expression",
      bs = {
        "browDown_L",
        "browDown_R",
        "browInnerUp",
        "browOuterUp_L",
        "browOuterUp_R",
        "cheekPuff",
        "eyeBlink_L",
        "eyeBlink_R",
        "eyeLookDown_L",
        "eyeLookDown_R",
        "eyeLookIn_L",
        "eyeLookIn_R",
        "eyeLookOut_L",
        "eyeLookOut_R",
        "eyeLookUp_L",
        "eyeLookUp_R",
        "eyeSquint_L",
        "eyeSquint_R",
        "eyeWide_L",
        "eyeWide_R",
        "jawForward",
        "jawLeft",
        "jawOpen",
        "jawOpenMouthClose",
        "jawRight",
        "mouthSmile_L",
        "mouthSmile_R",
        "mouthDimple_L",
        "mouthDimple_R",
        "mouthFrown_L",
        "mouthFrown_R",
        "mouthFunnel",
        "mouthLeft",
        "mouthLowerDown_L",
        "mouthLowerDown_R",
        "mouthPucker",
        "mouthRight",
        "mouthRollLower",
        "mouthRollUpper",
        "mouthShrugLower",
        "mouthShrugUpper",
        "mouthTightener",
        "mouthUpperUp_L",
        "mouthUpperUp_R",
        "noseSneer_L",
        "noseSneer_R"
      }
    },
    {
      name = "identity",
      bs = {
        "feature08_jawBConcave", 
        "feature08_jawBBulge", 
        "feature07_jawboneConcave", 
        "feature07_jawboneBulge", 
        "feature06_jawbonePointConcave", 
        "feature06_jawbonePointBulge", 
        "feature06_jawbonePointDownward", 
        "feature06_jawbonePointUpward", 
        "feature05_cheekConcave", 
        "feature05_cheekBulge", 
        "feature04_cheekboneBackward", 
        "feature04_cheekboneDownward", 
        "feature04_cheekboneForward", 
        "feature04_cheekboneUpward", 
        "feature04_cheekboneBulge", 
        "feature04_cheekboneConcave", 
        "feature03_jawBack", 
        "feature03_jawFront", 
        "feature03_jawFlat", 
        "feature03_jawPoint", 
        "feature03_jawShrink", 
        "feature03_jawStretch", 
        "feature02_headThin", 
        "feature02_headFat", 
        "feature02_headShort", 
        "feature02_headLong", 
        "feature01_superciliarisSunken", 
        "feature01_foreHeadBulge", 
        "feature01_foreHeadSunken", 
        "mouth05_mouthBackward", 
        "mouth05_mouthForward", 
        "mouth05_mouthBigger", 
        "mouth05_mouthSmaller", 
        "mouth05_mouthUpward", 
        "mouth05_mouthDownward", 
        "mouth04_mouthCornersUpward", 
        "mouth04_mouthCornersDownward", 
        "mouth04_mouthCornersStretch", 
        "mouth04_mouthCornersShrink", 
        "mouth03_lowerLipWide", 
        "mouth03_lowerLipThin", 
        "mouth03_lowerLipThick", 
        "mouth02_lipAlaDownward", 
        "mouth02_fishPearlBulge", 
        "mouth01_upperLipWiden", 
        "mouth01_upperLipThin", 
        "mouth01_upperLipThick", 
        "nose04_noseAlaBackward", 
        "nose04_noseAlaForward", 
        "nose04_noseAlaLower", 
        "nose04_noseAlaHigher", 
        "nose04_noseAlaNarrow", 
        "nose04_noseAlaWiden", 
        "nose03_noseTipSmaller", 
        "nose03_noseTipBigger", 
        "nose03_noseTipHigher", 
        "nose03_noseTipLower", 
        "nose03_noseTipUpward", 
        "nose03_noseTipDownward", 
        "nose02_noseBridgeNarrow", 
        "nose02_noseBridgeWiden", 
        "nose02_noseBridgeDownward", 
        "nose02_noseBridgeUpward", 
        "nose01_nasionNarrow", 
        "nose01_nasionWiden", 
        "nose01_nasionUpward", 
        "nose01_nasionDownward", 
        "eyes06_eyesBigger", 
        "eyes06_eyesSmaller", 
        "eyes05_outereyeCornerNarrow", 
        "eyes05_outereyeCornerEnlarge", 
        "eyes05_outereyeCornerShrink", 
        "eyes05_outereyeCornerStretch", 
        "eyes04_lowereyelidOuterDownward", 
        "eyes04_lowereyelidInnerDownward", 
        "eyes04_lowereyelidUpward", 
        "eyes04_lowereyelidDownward", 
        "eyes03_uppereyelidInnerUpward", 
        "eyes03_uppereyelidOuterUpward", 
        "eyes03_uppereyelidDownward", 
        "eyes03_uppereyelidUpward", 
        "eyes02_innereyeCornerNarrow", 
        "eyes02_innereyeCornerEnlarge", 
        "eyes02_innereyeCornerShrink", 
        "eyes02_innereyeCornerStretch", 
        "eyes01_eyesDownward", 
        "eyes01_eyesUpward", 
        "eyes01_eyesOutward", 
        "eyes01_eyesInward", 
        "brow04_browOuterInward", 
        "brow04_browOuterOutward", 
        "brow04_browOuterDownward", 
        "brow04_browOuterUpward", 
        "brow03_browMiddleInward", 
        "brow03_browMiddleOutUpward", 
        "brow03_browMiddleDownward", 
        "brow03_browMiddleUpward", 
        "brow02_browInnerInward", 
        "brow02_browInnerOutward", 
        "brow02_browInnerDownward", 
        "brow02_browInnerUpward", 
        "brow01_browInward", 
        "brow01_browOutward", 
        "brow01_browDownward", 
        "brow01_browUpward"
      }
    }
  },
  bs_none = "None",
  color_type = {
    "skin",
    "hair"
  },
  server_color_type_id = {
    albedo_color = 1,
    hair_color = 2
  },
  color_uniform = {
    "SkinTint",
    "colorTint"
  },
  animation_status = {
    -- order by important
    PLAYING = 0,
    DONE = 1,
    STOP = 2,
    ERROR = 3
  },
  result_code = {
    SUCCESS = {
      0,  -- DEFAULT
      1,  -- CUSTOM
      2   -- PARTIAL
    },
    ERROR = {
      3,  -- DEFAULT
      4,  -- CUSTOM
      5   -- PARTIAL
    },
    STOP = {
      6,  -- DEFAULT
      7,  -- CUSTOM
      8   -- PARTIAL
    }
  },
  resource_status = {
    DEFAULT = 1,
    CUSTOM = 2,
    PARTIAL = 3
  }
}

return defined