

#DEFPARAMS
GAUSSIAN_STEP = { "GAUSSIAN_STEP", VEC2, "5.0,5.0" },
INPUTSIZE = { "INPUTSIZE", VEC2, "500.0,500.0" },
WIDTH = {"WIDTH", FLOAT, "0.0"},
halfWidth = {"halfWidth", FLOAT, "5.0"},
#END

#DEFTAG
ShaderName = "glow"
RenderQueue = "PostEffect"
#END

#DEFPASS Always
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_OFF, DEPTH_TEST_OFF }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#include "common.inc"

struct appdata
{
	float4 vertex : POSITION;
	float2 uv : TEXCOORD0;
};

struct v2f
{
	float2 uv : TEXCOORD0;
	float4 vertex : SV_POSITION;
};

sampler2D TEXTURE_DIFFUSE;
float2 INPUTSIZE;
float2 GAUSSIAN_STEP;
float WIDTH;

v2f vert(appdata v)
{
	v2f o;
	o.vertex = UniformNDC(v.vertex);
	o.uv = v.uv.xy;


	return o;
}

float4 frag(v2f i) : SV_Target
{
	//float halfWidth = 5;//min(SIGMA, 5);
	float2 inCoord = i.uv;
    // float4 color = tex2D(TEXTURE_DIFFUSE, inCoord);
    // float norm = 1.0;
	// float alpha = color.r;
	// for(int k=1; k<=WIDTH; k++)
	// {
    //     float2 step = GAUSSIAN_STEP * k;
	// 	// float2 uv1 = clamp(inCoord - step, float2(0.001,0.001), float2(0.999,0.999));
	// 	// float2 uv2 = clamp(inCoord + step, float2(0.001,0.001), float2(0.999,0.999));
	// 	float2 uv1 = inCoord - step;
	// 	float2 uv2 = inCoord + step;
	// 	float loca = 0.0;
	// 	if(uv1.x>=0.001&&uv1.x<=0.999&&uv1.y>=0.001&&uv1.y<=0.999){
	// 		loca += tex2D(TEXTURE_DIFFUSE, uv1).r;
	// 	}
	// 	if(uv2.x>=0.001&&uv2.x<=0.999&&uv2.y>=0.001&&uv2.y<=0.999){
	// 		loca += tex2D(TEXTURE_DIFFUSE, uv2).r;
	// 	}
	// 	// float loca = tex2D(TEXTURE_DIFFUSE, uv1).r+tex2D(TEXTURE_DIFFUSE, uv2).r;
    //     norm += 2.0;
    //     alpha += loca;
	// }
	// alpha = alpha / norm;
	float2 gaussianCoord[7];
	float2 step = GAUSSIAN_STEP;
	float2 step2 = step + step;
	float2 step3 = step2 + step;

	gaussianCoord[0] = inCoord;
	gaussianCoord[1] = inCoord - step;
	gaussianCoord[2] = inCoord + step;
	gaussianCoord[3] = inCoord - step2;
	gaussianCoord[4] = inCoord + step2;
	gaussianCoord[5] = inCoord - step3;
	gaussianCoord[6] = inCoord + step3;
	float Weight[7];
	Weight[0] = 0.34;
	Weight[1] = Weight[2] = 0.17;
	Weight[3] = Weight[4] = 0.10;
	Weight[5] = Weight[6] = 0.06;
	
	float4 color = float4(0.0,0.0,0.0,0.0);

	color += Weight[0] * tex2D(TEXTURE_DIFFUSE, gaussianCoord[0]);
	if(gaussianCoord[1].x>=0.001&&gaussianCoord[1].x<=0.999&&gaussianCoord[1].y>=0.001&&gaussianCoord[1].y){
		color += Weight[1] * tex2D(TEXTURE_DIFFUSE, gaussianCoord[1]);
	}
	if(gaussianCoord[2].x>=0.001&&gaussianCoord[2].x<=0.999&&gaussianCoord[2].y>=0.001&&gaussianCoord[2].y){
		color += Weight[2] * tex2D(TEXTURE_DIFFUSE, gaussianCoord[2]);
	}
	if(gaussianCoord[3].x>=0.001&&gaussianCoord[3].x<=0.999&&gaussianCoord[3].y>=0.001&&gaussianCoord[3].y){
		color += Weight[3] * tex2D(TEXTURE_DIFFUSE, gaussianCoord[3]);
	}
	if(gaussianCoord[4].x>=0.001&&gaussianCoord[4].x<=0.999&&gaussianCoord[4].y>=0.001&&gaussianCoord[4].y){
		color += Weight[4] * tex2D(TEXTURE_DIFFUSE, gaussianCoord[4]);
	}
	if(gaussianCoord[5].x>=0.001&&gaussianCoord[5].x<=0.999&&gaussianCoord[5].y>=0.001&&gaussianCoord[5].y){
		color += Weight[5] * tex2D(TEXTURE_DIFFUSE, gaussianCoord[5]);
	}
	if(gaussianCoord[6].x>=0.001&&gaussianCoord[6].x<=0.999&&gaussianCoord[6].y>=0.001&&gaussianCoord[6].y){
		color += Weight[6] * tex2D(TEXTURE_DIFFUSE, gaussianCoord[6]);
	}
	return float4(color.r, color.r, color.r, tex2D(TEXTURE_DIFFUSE, gaussianCoord[0]).a);

	// return float4(alpha, alpha, alpha, color.a);
}
ENDCG
#END
