

#DEFPARAMS
_MainTex = { "main Color", TEXTURE2D, "white" },
_MainTexOffset = { "mainTex uv offset", VEC2, "0.0, 0.0"},
_MainTexTilling = { "mainTex uv tilling", VEC2, "1.0, 1.0"},
_FurTex = { "Fur Pattern", TEXTURE2D, "white" },
_FurTexOffset = { "furTex uv offset", VEC2, "0.0, 0.0"},
_FurTexTilling = { "furTex uv tilling", VEC2, "1.0, 1.0"},
_Gravity = { "Gravity Direction", VEC4, "0.0, -1.0, 0.0, 0.0" },
_GravityStrength = { "Gravity Strength", FLOAT, "0.0" },
_FurLength = { "Fur Length", FLOATRANGE, "0.01, 0.1, 0.0"},
_FresnelLV = { "FresnelLV", FLOATRANGE, "5.0, 100.0, 0.0"},
_UVOffset = { "uv offset", VEC2, "0.0, 0.0"},
_OcclusionColor = {"OcclusionColor Color", COLOR, "0.0,0.0,0.0,1.0"},
_DirLightFilter = {"DirLightFilter", FLOATRANGE, "0.0, 0.5, -0.5" },
_FurDirLightExposure = {"FurDirLightExposure", FLOATRANGE, "0.0, 1.0, -1.0" },
_Thickness = {"Thickness", FLOATRANGE, "1.0, 5.0, 1.0" }, 
#END

#DEFTAG
ShaderName = "fur"
RenderQueue = "Transparent"
#END

#DEFPASS ForwardBase0
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT_BASE(0)
FRAG_BASE(0)
ENDCG
#END

#DEFPASS ForwardBase1
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE } 

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.05)
FRAG(0.05)
ENDCG
#END


#DEFPASS ForwardBase2
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.1)
FRAG(0.1)
ENDCG
#END

#DEFPASS ForwardBase3
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.15)
FRAG(0.15)
ENDCG
#END


#DEFPASS ForwardBase4
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.2)
FRAG(0.2)
ENDCG
#END

#DEFPASS ForwardBase5
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.25)
FRAG(0.25)
ENDCG
#END

#DEFPASS ForwardBase6
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.3)
FRAG(0.3)
ENDCG
#END

#DEFPASS ForwardBase7
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.35)
FRAG(0.35)
ENDCG
#END

#DEFPASS ForwardBase8
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.4)
FRAG(0.4)
ENDCG
#END

#DEFPASS ForwardBase9
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.45)
FRAG(0.45)
ENDCG
#END

#DEFPASS ForwardBase10
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.5)
FRAG(0.5)
ENDCG
#END

#DEFPASS ForwardBase11
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.55)
FRAG(0.55)
ENDCG
#END

#DEFPASS ForwardBase12
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.6)
FRAG(0.6)
ENDCG
#END

#DEFPASS ForwardBase13
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.65)
FRAG(0.65)
ENDCG
#END

#DEFPASS ForwardBase14
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.7)
FRAG(0.7)
ENDCG
#END

#DEFPASS ForwardBase15
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.75)
FRAG(0.75)
ENDCG
#END

#DEFPASS ForwardBase16
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.8)
FRAG(0.8)
ENDCG
#END

#DEFPASS ForwardBase17
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.85)
FRAG(0.85)
ENDCG
#END

#DEFPASS ForwardBase18
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.9)
FRAG(0.9)
ENDCG
#END

#DEFPASS ForwardBase19
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(0.95)
FRAG(0.95)
ENDCG
#END

#DEFPASS ForwardBase20
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { FORWARDBASE }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile_fwdbase
#pragma multi_compile_skin
#include "light.inc"
#include "fur.inc"
FUR_LAYER(_FurLength)
VERT(1.0)
FRAG(1.0)
ENDCG
#END
