

#DEFPARAMS
TEXTURE_CLIPART = { "Clipart", TEXTURE2D, "white" },
#END

#DEFTAG
ShaderName = "ClipartBlendScreen"
RenderQueue = "PostEffect"
#END

#DEFPASS Always
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_OFF, DEPTH_TEST_OFF }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#include "common.inc"

struct appdata
{
	float4 vertex : POSITION;
	float2 uv : TEXCOORD0;
};

struct v2f
{
	float2 uv : TEXCOORD0;
	float4 vertex : SV_POSITION;
};

sampler2D TEXTURE_DIFFUSE;
sampler2D TEXTURE_CLIPART;

v2f vert(appdata v)
{
	v2f o;
	o.vertex = UniformNDC(v.vertex);
	o.uv = v.uv.xy;

	return o;
}

float4 frag(v2f i) : SV_Target
{
	float4 dstColor = tex2D(TEXTURE_DIFFUSE, i.uv);
	float4 srcColor = tex2D(TEXTURE_CLIPART, i.uv);

	return float4(1.0 - (1.0 - srcColor.rgb) * (1.0 - dstColor.rgb), 1.0);
}
ENDCG
#END
