

function DefineParams()
	Properties = 
	{
		
GAUSSIAN_STEP = { "GaussianStep", VEC2, "5.0,5.0" },

POST_EFFECT_ALPHA = {"post_effect_alpha", FLOAT, "0.0"},

	}
	Attributes = 
	{
		POST_EFFECT_ALPHA = "Keywords(POST_EFFECT_ALPHA_ON,POST_EFFECT_ALPHA_OFF)", 
	}
	
end



function Init()
	PassNames = 
	{
		"Always"
	}

ShaderName = "GaussianBlur"
RenderQueue = "PostEffect"
end

function Always()

COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_OFF, DEPTH_TEST_OFF }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }


Programs =
{
	{
		shaderApi = "gles3",
		keyWords = {"POST_EFFECT_ALPHA_ON"},
		vsBufferSize = "0",
		vsAttributes = {
		},
		vsUniforms = {
			{
				varName = "DEVICE_COORDINATE_Y_FLIP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		psBufferSize = "0",
		psUniforms = {
			{
				varName = "TEXTURE_DIFFUSE",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "GAUSSIAN_STEP",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		vsShader = [===[#version 300 es
in vec4 _glesVertex;
in vec4 _glesMultiTexCoord0;
uniform highp float DEVICE_COORDINATE_Y_FLIP;
out highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.xzw = vec3(1.0, 1.0, 1.0);
  tmpvar_1.y = DEVICE_COORDINATE_Y_FLIP;
  xlv_TEXCOORD0 = _glesMultiTexCoord0.xy;
  gl_Position = (tmpvar_1 * _glesVertex);
}

]===],
		psShader = [===[#version 300 es
layout(location=0) out mediump vec4 _glesFragData[1];
uniform sampler2D TEXTURE_DIFFUSE;
uniform highp vec2 GAUSSIAN_STEP;
in highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 color_1;
  highp vec2 gaussianCoord_1_2;
  highp vec2 gaussianCoord_2_3;
  highp vec2 gaussianCoord_3_4;
  highp vec2 gaussianCoord_4_5;
  highp vec2 gaussianCoord_5_6;
  highp vec2 gaussianCoord_6_7;
  highp vec2 tmpvar_8;
  tmpvar_8 = (GAUSSIAN_STEP + GAUSSIAN_STEP);
  highp vec2 tmpvar_9;
  tmpvar_9 = (tmpvar_8 + GAUSSIAN_STEP);
  gaussianCoord_1_2 = (xlv_TEXCOORD0 - GAUSSIAN_STEP);
  gaussianCoord_2_3 = (xlv_TEXCOORD0 + GAUSSIAN_STEP);
  gaussianCoord_3_4 = (xlv_TEXCOORD0 - tmpvar_8);
  gaussianCoord_4_5 = (xlv_TEXCOORD0 + tmpvar_8);
  gaussianCoord_5_6 = (xlv_TEXCOORD0 - tmpvar_9);
  gaussianCoord_6_7 = (xlv_TEXCOORD0 + tmpvar_9);
  lowp vec4 tmpvar_10;
  tmpvar_10 = texture (TEXTURE_DIFFUSE, xlv_TEXCOORD0);
  color_1 = (0.34 * tmpvar_10);
  lowp vec4 tmpvar_11;
  tmpvar_11 = texture (TEXTURE_DIFFUSE, gaussianCoord_1_2);
  color_1 = (color_1 + (0.17 * tmpvar_11));
  lowp vec4 tmpvar_12;
  tmpvar_12 = texture (TEXTURE_DIFFUSE, gaussianCoord_2_3);
  color_1 = (color_1 + (0.17 * tmpvar_12));
  lowp vec4 tmpvar_13;
  tmpvar_13 = texture (TEXTURE_DIFFUSE, gaussianCoord_3_4);
  color_1 = (color_1 + (0.1 * tmpvar_13));
  lowp vec4 tmpvar_14;
  tmpvar_14 = texture (TEXTURE_DIFFUSE, gaussianCoord_4_5);
  color_1 = (color_1 + (0.1 * tmpvar_14));
  lowp vec4 tmpvar_15;
  tmpvar_15 = texture (TEXTURE_DIFFUSE, gaussianCoord_5_6);
  color_1 = (color_1 + (0.06 * tmpvar_15));
  lowp vec4 tmpvar_16;
  tmpvar_16 = texture (TEXTURE_DIFFUSE, gaussianCoord_6_7);
  color_1 = (color_1 + (0.06 * tmpvar_16));
  _glesFragData[0] = color_1;
}

]===],
	},
	{
		shaderApi = "gles3",
		keyWords = {"POST_EFFECT_ALPHA_OFF"},
		vsBufferSize = "0",
		vsAttributes = {
		},
		vsUniforms = {
			{
				varName = "DEVICE_COORDINATE_Y_FLIP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		psBufferSize = "0",
		psUniforms = {
			{
				varName = "TEXTURE_DIFFUSE",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "GAUSSIAN_STEP",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		vsShader = [===[#version 300 es
in vec4 _glesVertex;
in vec4 _glesMultiTexCoord0;
uniform highp float DEVICE_COORDINATE_Y_FLIP;
out highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.xzw = vec3(1.0, 1.0, 1.0);
  tmpvar_1.y = DEVICE_COORDINATE_Y_FLIP;
  xlv_TEXCOORD0 = _glesMultiTexCoord0.xy;
  gl_Position = (tmpvar_1 * _glesVertex);
}

]===],
		psShader = [===[#version 300 es
layout(location=0) out mediump vec4 _glesFragData[1];
uniform sampler2D TEXTURE_DIFFUSE;
uniform highp vec2 GAUSSIAN_STEP;
in highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec3 color_1;
  highp vec2 gaussianCoord_1_2;
  highp vec2 gaussianCoord_2_3;
  highp vec2 gaussianCoord_3_4;
  highp vec2 gaussianCoord_4_5;
  highp vec2 gaussianCoord_5_6;
  highp vec2 gaussianCoord_6_7;
  highp vec2 tmpvar_8;
  tmpvar_8 = (GAUSSIAN_STEP + GAUSSIAN_STEP);
  highp vec2 tmpvar_9;
  tmpvar_9 = (tmpvar_8 + GAUSSIAN_STEP);
  gaussianCoord_1_2 = (xlv_TEXCOORD0 - GAUSSIAN_STEP);
  gaussianCoord_2_3 = (xlv_TEXCOORD0 + GAUSSIAN_STEP);
  gaussianCoord_3_4 = (xlv_TEXCOORD0 - tmpvar_8);
  gaussianCoord_4_5 = (xlv_TEXCOORD0 + tmpvar_8);
  gaussianCoord_5_6 = (xlv_TEXCOORD0 - tmpvar_9);
  gaussianCoord_6_7 = (xlv_TEXCOORD0 + tmpvar_9);
  lowp vec4 tmpvar_10;
  tmpvar_10 = texture (TEXTURE_DIFFUSE, xlv_TEXCOORD0);
  color_1 = (0.34 * tmpvar_10.xyz);
  lowp vec4 tmpvar_11;
  tmpvar_11 = texture (TEXTURE_DIFFUSE, gaussianCoord_1_2);
  color_1 = (color_1 + (0.17 * tmpvar_11.xyz));
  lowp vec4 tmpvar_12;
  tmpvar_12 = texture (TEXTURE_DIFFUSE, gaussianCoord_2_3);
  color_1 = (color_1 + (0.17 * tmpvar_12.xyz));
  lowp vec4 tmpvar_13;
  tmpvar_13 = texture (TEXTURE_DIFFUSE, gaussianCoord_3_4);
  color_1 = (color_1 + (0.1 * tmpvar_13.xyz));
  lowp vec4 tmpvar_14;
  tmpvar_14 = texture (TEXTURE_DIFFUSE, gaussianCoord_4_5);
  color_1 = (color_1 + (0.1 * tmpvar_14.xyz));
  lowp vec4 tmpvar_15;
  tmpvar_15 = texture (TEXTURE_DIFFUSE, gaussianCoord_5_6);
  color_1 = (color_1 + (0.06 * tmpvar_15.xyz));
  lowp vec4 tmpvar_16;
  tmpvar_16 = texture (TEXTURE_DIFFUSE, gaussianCoord_6_7);
  color_1 = (color_1 + (0.06 * tmpvar_16.xyz));
  highp vec4 tmpvar_17;
  tmpvar_17.w = 1.0;
  tmpvar_17.xyz = color_1;
  _glesFragData[0] = tmpvar_17;
}

]===],
	},
}

end
