

#DEFPARAMS
BLEND_FACTOR = {"BlendFactor", FLOAT, "1.0"},
[Keywords(POST_EFFECT_ALPHA_ON, POST_EFFECT_ALPHA_OFF)]
POST_EFFECT_ALPHA = {"post_effect_alpha", FLOAT, "0.0"},
#END

#DEFTAG
ShaderName = "Invert"
RenderQueue = "PostEffect"
#END

#DEFPASS Always
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_OFF, DEPTH_TEST_OFF }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#pragma multi_compile POST_EFFECT_ALPHA_ON POST_EFFECT_ALPHA_OFF
#include "common.inc"

struct appdata
{
	float4 vertex : POSITION;
	float2 uv : TEXCOORD0;
};

struct v2f
{
	float2 uv : TEXCOORD0;
	float4 vertex : SV_POSITION;
};

sampler2D TEXTURE_DIFFUSE;
float BLEND_FACTOR;

v2f vert(appdata v)
{
	v2f o;
	o.vertex = UniformNDC(v.vertex);
	o.uv = v.uv.xy;

	return o;
}

float4 frag(v2f i) : SV_Target
{
	#ifdef POST_EFFECT_ALPHA_OFF
		float3 color = tex2D(TEXTURE_DIFFUSE, i.uv).rgb;
		color = color * BLEND_FACTOR + (1.0f - color) * (1.0f - BLEND_FACTOR);
		return float4(color, 1.0f);
	#elif POST_EFFECT_ALPHA_ON
		float4 color = tex2D(TEXTURE_DIFFUSE, i.uv);
		color.rgb = color.rgb * BLEND_FACTOR + (1.0f - color.rgb) * (1.0f - BLEND_FACTOR);
		return color;
	#endif
}
ENDCG
#END
