

#DEFPARAMS
#END

#DEFTAG
ShaderName = "Luminance"
RenderQueue = "PostEffect"
#END

#DEFPASS Always
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_OFF, DEPTH_TEST_OFF }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#include "common.inc"

struct appdata
{
	float4 vertex : POSITION;
	float2 uv : TEXCOORD0;
};

struct v2f
{
	float2 uv : TEXCOORD0;
	float4 vertex : SV_POSITION;
};

sampler2D TEXTURE_DIFFUSE;
float3 BLOOM_COLOR;
float LUMINACE_THRESHOLD;

v2f vert(appdata v)
{
	v2f o;
	o.vertex = UniformNDC(v.vertex);
	o.uv = v.uv.xy;

	return o;
}

float4 frag(v2f i) : SV_Target
{
	float4 color = tex2D(TEXTURE_DIFFUSE, i.uv);
	
	float illumination = dot(color.xyz, float3(0.3, 0.59, 0.11));
	// //we will not drop any pixel, we pull up and down pixel color
	fixed4 out_TextureColor = float4(color.xyz * step(0.0, illumination - LUMINACE_THRESHOLD), color.a);

	return out_TextureColor;
}
ENDCG
#END
