
#DEFPARAMS
TEXTURE_DIFFUSE = { "tex diffuse", TEXTURE2D, "white" },
#END

#DEFTAG
ShaderName = "SimpleNtNCull"
RenderQueue = "Opaque"
#END

#DEFPASS Always
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#include "common.inc"

struct appdata
{
	float4 position : POSITION;
	float2 uv : TEXCOORD0;
};

struct v2f
{
	float4 position : SV_POSITION;
	float2 uv : TEXCOORD0;
};

float3x3 LOCALWORLD_ROTATION;
sampler2D TEXTURE_DIFFUSE;

v2f vert(appdata v)
{
	v2f o;
	float4 positionWS = mul(LOCALWORLD_TRANSFORM, v.position);
	o.position = mul(CAMERA_VIEWPROJ, positionWS);
	o.position = UniformNDC(o.position);
	o.uv = v.uv;

	return o;
}

float4 frag(v2f i) : SV_Target
{
	return tex2D(TEXTURE_DIFFUSE, i.uv);
}
ENDCG
#END
