

function DefineParams()
	Properties = 
	{
		
UNIFORM_BLUR_CENTER = { "BlurCenter", VEC2, "1.0, 1.0"},
UNIFORM_BLUR_SCALE = { "BlurScale", FLOAT, "1.0"},

POST_EFFECT_ALPHA = {"post_effect_alpha", FLOAT, "0.0"},

	}
	Attributes = 
	{
		POST_EFFECT_ALPHA = "Keywords(POST_EFFECT_ALPHA_ON,POST_EFFECT_ALPHA_OFF)", 
	}
	
end



function Init()
	PassNames = 
	{
		"Always"
	}

ShaderName = "radialblur"
RenderQueue = "PostEffect"
end

function Always()

COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_OFF, DEPTH_TEST_OFF }
STENCIL_MODE = {STENCIL_OFF}
LIGHT_MODE = { ALWAYS }


Programs =
{
	{
		shaderApi = "gles3",
		keyWords = {"POST_EFFECT_ALPHA_ON"},
		vsBufferSize = "0",
		vsAttributes = {
		},
		vsUniforms = {
			{
				varName = "DEVICE_COORDINATE_Y_FLIP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		psBufferSize = "0",
		psUniforms = {
			{
				varName = "TEXTURE_DIFFUSE",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "UNIFORM_BLUR_CENTER",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "UNIFORM_BLUR_SCALE",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		vsShader = [===[#version 300 es
in vec4 _glesVertex;
in vec4 _glesMultiTexCoord0;
uniform highp float DEVICE_COORDINATE_Y_FLIP;
out highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.xzw = vec3(1.0, 1.0, 1.0);
  tmpvar_1.y = DEVICE_COORDINATE_Y_FLIP;
  gl_Position = (tmpvar_1 * _glesVertex);
  xlv_TEXCOORD0 = _glesMultiTexCoord0.xy;
}

]===],
		psShader = [===[#version 300 es
layout(location=0) out mediump vec4 _glesFragData[1];
uniform sampler2D TEXTURE_DIFFUSE;
uniform highp vec2 UNIFORM_BLUR_CENTER;
uniform highp float UNIFORM_BLUR_SCALE;
in highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 rgba_1;
  highp vec2 tmpvar_2;
  tmpvar_2 = (UNIFORM_BLUR_CENTER - xlv_TEXCOORD0);
  lowp vec4 tmpvar_3;
  tmpvar_3 = texture (TEXTURE_DIFFUSE, xlv_TEXCOORD0);
  rgba_1 = tmpvar_3;
  lowp vec4 tmpvar_4;
  highp vec2 P_5;
  P_5 = (xlv_TEXCOORD0 + (UNIFORM_BLUR_SCALE * tmpvar_2));
  tmpvar_4 = texture (TEXTURE_DIFFUSE, P_5);
  rgba_1 = (tmpvar_4 + rgba_1);
  lowp vec4 tmpvar_6;
  highp vec2 P_7;
  P_7 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 2.0));
  tmpvar_6 = texture (TEXTURE_DIFFUSE, P_7);
  rgba_1 = (tmpvar_6 + rgba_1);
  lowp vec4 tmpvar_8;
  highp vec2 P_9;
  P_9 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 3.0));
  tmpvar_8 = texture (TEXTURE_DIFFUSE, P_9);
  rgba_1 = (tmpvar_8 + rgba_1);
  lowp vec4 tmpvar_10;
  highp vec2 P_11;
  P_11 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 4.0));
  tmpvar_10 = texture (TEXTURE_DIFFUSE, P_11);
  rgba_1 = (tmpvar_10 + rgba_1);
  lowp vec4 tmpvar_12;
  highp vec2 P_13;
  P_13 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 5.0));
  tmpvar_12 = texture (TEXTURE_DIFFUSE, P_13);
  rgba_1 = (tmpvar_12 + rgba_1);
  lowp vec4 tmpvar_14;
  highp vec2 P_15;
  P_15 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 6.0));
  tmpvar_14 = texture (TEXTURE_DIFFUSE, P_15);
  rgba_1 = (tmpvar_14 + rgba_1);
  lowp vec4 tmpvar_16;
  highp vec2 P_17;
  P_17 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 7.0));
  tmpvar_16 = texture (TEXTURE_DIFFUSE, P_17);
  rgba_1 = (tmpvar_16 + rgba_1);
  lowp vec4 tmpvar_18;
  highp vec2 P_19;
  P_19 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 8.0));
  tmpvar_18 = texture (TEXTURE_DIFFUSE, P_19);
  rgba_1 = (tmpvar_18 + rgba_1);
  lowp vec4 tmpvar_20;
  highp vec2 P_21;
  P_21 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 9.0));
  tmpvar_20 = texture (TEXTURE_DIFFUSE, P_21);
  rgba_1 = (tmpvar_20 + rgba_1);
  lowp vec4 tmpvar_22;
  highp vec2 P_23;
  P_23 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 10.0));
  tmpvar_22 = texture (TEXTURE_DIFFUSE, P_23);
  rgba_1 = (tmpvar_22 + rgba_1);
  lowp vec4 tmpvar_24;
  highp vec2 P_25;
  P_25 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 11.0));
  tmpvar_24 = texture (TEXTURE_DIFFUSE, P_25);
  rgba_1 = (tmpvar_24 + rgba_1);
  lowp vec4 tmpvar_26;
  highp vec2 P_27;
  P_27 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 12.0));
  tmpvar_26 = texture (TEXTURE_DIFFUSE, P_27);
  rgba_1 = (tmpvar_26 + rgba_1);
  lowp vec4 tmpvar_28;
  highp vec2 P_29;
  P_29 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 13.0));
  tmpvar_28 = texture (TEXTURE_DIFFUSE, P_29);
  rgba_1 = (tmpvar_28 + rgba_1);
  lowp vec4 tmpvar_30;
  highp vec2 P_31;
  P_31 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 14.0));
  tmpvar_30 = texture (TEXTURE_DIFFUSE, P_31);
  rgba_1 = (tmpvar_30 + rgba_1);
  lowp vec4 tmpvar_32;
  highp vec2 P_33;
  P_33 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 15.0));
  tmpvar_32 = texture (TEXTURE_DIFFUSE, P_33);
  rgba_1 = (tmpvar_32 + rgba_1);
  lowp vec4 tmpvar_34;
  highp vec2 P_35;
  P_35 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 16.0));
  tmpvar_34 = texture (TEXTURE_DIFFUSE, P_35);
  rgba_1 = (tmpvar_34 + rgba_1);
  lowp vec4 tmpvar_36;
  highp vec2 P_37;
  P_37 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 17.0));
  tmpvar_36 = texture (TEXTURE_DIFFUSE, P_37);
  rgba_1 = (tmpvar_36 + rgba_1);
  lowp vec4 tmpvar_38;
  highp vec2 P_39;
  P_39 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 18.0));
  tmpvar_38 = texture (TEXTURE_DIFFUSE, P_39);
  rgba_1 = (tmpvar_38 + rgba_1);
  lowp vec4 tmpvar_40;
  highp vec2 P_41;
  P_41 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 19.0));
  tmpvar_40 = texture (TEXTURE_DIFFUSE, P_41);
  rgba_1 = (tmpvar_40 + rgba_1);
  rgba_1 = (rgba_1 / 20.0);
  _glesFragData[0] = rgba_1;
}

]===],
	},
	{
		shaderApi = "gles3",
		keyWords = {"POST_EFFECT_ALPHA_OFF"},
		vsBufferSize = "0",
		vsAttributes = {
		},
		vsUniforms = {
			{
				varName = "DEVICE_COORDINATE_Y_FLIP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		psBufferSize = "0",
		psUniforms = {
			{
				varName = "TEXTURE_DIFFUSE",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "UNIFORM_BLUR_CENTER",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "UNIFORM_BLUR_SCALE",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		vsShader = [===[#version 300 es
in vec4 _glesVertex;
in vec4 _glesMultiTexCoord0;
uniform highp float DEVICE_COORDINATE_Y_FLIP;
out highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.xzw = vec3(1.0, 1.0, 1.0);
  tmpvar_1.y = DEVICE_COORDINATE_Y_FLIP;
  gl_Position = (tmpvar_1 * _glesVertex);
  xlv_TEXCOORD0 = _glesMultiTexCoord0.xy;
}

]===],
		psShader = [===[#version 300 es
layout(location=0) out mediump vec4 _glesFragData[1];
uniform sampler2D TEXTURE_DIFFUSE;
uniform highp vec2 UNIFORM_BLUR_CENTER;
uniform highp float UNIFORM_BLUR_SCALE;
in highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec3 rgb_1;
  highp vec2 tmpvar_2;
  tmpvar_2 = (UNIFORM_BLUR_CENTER - xlv_TEXCOORD0);
  lowp vec3 tmpvar_3;
  tmpvar_3 = texture (TEXTURE_DIFFUSE, xlv_TEXCOORD0).xyz;
  rgb_1 = tmpvar_3;
  lowp vec4 tmpvar_4;
  highp vec2 P_5;
  P_5 = (xlv_TEXCOORD0 + (UNIFORM_BLUR_SCALE * tmpvar_2));
  tmpvar_4 = texture (TEXTURE_DIFFUSE, P_5);
  rgb_1 = (tmpvar_4.xyz + rgb_1);
  lowp vec4 tmpvar_6;
  highp vec2 P_7;
  P_7 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 2.0));
  tmpvar_6 = texture (TEXTURE_DIFFUSE, P_7);
  rgb_1 = (tmpvar_6.xyz + rgb_1);
  lowp vec4 tmpvar_8;
  highp vec2 P_9;
  P_9 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 3.0));
  tmpvar_8 = texture (TEXTURE_DIFFUSE, P_9);
  rgb_1 = (tmpvar_8.xyz + rgb_1);
  lowp vec4 tmpvar_10;
  highp vec2 P_11;
  P_11 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 4.0));
  tmpvar_10 = texture (TEXTURE_DIFFUSE, P_11);
  rgb_1 = (tmpvar_10.xyz + rgb_1);
  lowp vec4 tmpvar_12;
  highp vec2 P_13;
  P_13 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 5.0));
  tmpvar_12 = texture (TEXTURE_DIFFUSE, P_13);
  rgb_1 = (tmpvar_12.xyz + rgb_1);
  lowp vec4 tmpvar_14;
  highp vec2 P_15;
  P_15 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 6.0));
  tmpvar_14 = texture (TEXTURE_DIFFUSE, P_15);
  rgb_1 = (tmpvar_14.xyz + rgb_1);
  lowp vec4 tmpvar_16;
  highp vec2 P_17;
  P_17 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 7.0));
  tmpvar_16 = texture (TEXTURE_DIFFUSE, P_17);
  rgb_1 = (tmpvar_16.xyz + rgb_1);
  lowp vec4 tmpvar_18;
  highp vec2 P_19;
  P_19 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 8.0));
  tmpvar_18 = texture (TEXTURE_DIFFUSE, P_19);
  rgb_1 = (tmpvar_18.xyz + rgb_1);
  lowp vec4 tmpvar_20;
  highp vec2 P_21;
  P_21 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 9.0));
  tmpvar_20 = texture (TEXTURE_DIFFUSE, P_21);
  rgb_1 = (tmpvar_20.xyz + rgb_1);
  lowp vec4 tmpvar_22;
  highp vec2 P_23;
  P_23 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 10.0));
  tmpvar_22 = texture (TEXTURE_DIFFUSE, P_23);
  rgb_1 = (tmpvar_22.xyz + rgb_1);
  lowp vec4 tmpvar_24;
  highp vec2 P_25;
  P_25 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 11.0));
  tmpvar_24 = texture (TEXTURE_DIFFUSE, P_25);
  rgb_1 = (tmpvar_24.xyz + rgb_1);
  lowp vec4 tmpvar_26;
  highp vec2 P_27;
  P_27 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 12.0));
  tmpvar_26 = texture (TEXTURE_DIFFUSE, P_27);
  rgb_1 = (tmpvar_26.xyz + rgb_1);
  lowp vec4 tmpvar_28;
  highp vec2 P_29;
  P_29 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 13.0));
  tmpvar_28 = texture (TEXTURE_DIFFUSE, P_29);
  rgb_1 = (tmpvar_28.xyz + rgb_1);
  lowp vec4 tmpvar_30;
  highp vec2 P_31;
  P_31 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 14.0));
  tmpvar_30 = texture (TEXTURE_DIFFUSE, P_31);
  rgb_1 = (tmpvar_30.xyz + rgb_1);
  lowp vec4 tmpvar_32;
  highp vec2 P_33;
  P_33 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 15.0));
  tmpvar_32 = texture (TEXTURE_DIFFUSE, P_33);
  rgb_1 = (tmpvar_32.xyz + rgb_1);
  lowp vec4 tmpvar_34;
  highp vec2 P_35;
  P_35 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 16.0));
  tmpvar_34 = texture (TEXTURE_DIFFUSE, P_35);
  rgb_1 = (tmpvar_34.xyz + rgb_1);
  lowp vec4 tmpvar_36;
  highp vec2 P_37;
  P_37 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 17.0));
  tmpvar_36 = texture (TEXTURE_DIFFUSE, P_37);
  rgb_1 = (tmpvar_36.xyz + rgb_1);
  lowp vec4 tmpvar_38;
  highp vec2 P_39;
  P_39 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 18.0));
  tmpvar_38 = texture (TEXTURE_DIFFUSE, P_39);
  rgb_1 = (tmpvar_38.xyz + rgb_1);
  lowp vec4 tmpvar_40;
  highp vec2 P_41;
  P_41 = (xlv_TEXCOORD0 + ((UNIFORM_BLUR_SCALE * tmpvar_2) * 19.0));
  tmpvar_40 = texture (TEXTURE_DIFFUSE, P_41);
  rgb_1 = (tmpvar_40.xyz + rgb_1);
  rgb_1 = (rgb_1 / 20.0);
  highp vec4 tmpvar_42;
  tmpvar_42.w = 1.0;
  tmpvar_42.xyz = rgb_1;
  _glesFragData[0] = tmpvar_42;
}

]===],
	},
}

end
