#SHADER_DEFINE NormalVertex

    FUNCTION_INPUT = 
    {
        { ATTRIBUTE_POSITION,        HIGH,    VEC4,        "in_Position" },
        { ATTRIBUTE_COORDNATE0,      HIGH,    VEC2,        "in_TexCoordinate" },
    }
    FUNCTION_OUTPUT =
    {
        { ATTRIBUTE_COORDNATE0,      HIGH,    VEC2,        "out_TexCoordinate" },
    }

#SHADER_CODE

    gl_Position = in_Position;
    vec2 out_TexCoordinate = in_TexCoordinate.xy;

#END_CODE
#END_DEFINE


#SHADER_DEFINE  NormalFragment

    FUNCTION_INPUT = 
    {
        { TEXTURE_DIFFUSE,           NONE,      TEXTURE2D,   "in_DiffuseTexture" },
        { TEXTURE_BLEND,             NONE,      TEXTURE2D,   "in_BlendTexture"},
        { ATTRIBUTE_COORDNATE0,      HIGH,      VEC2,        "in_TexCoordinate" },
        
    }

#SHADER_CODE
    vec3 basecolor = texture2D(in_DiffuseTexture, in_TexCoordinate).rgb; //左视频 背景
    vec3 blendcolor = texture2D(in_BlendTexture,  in_TexCoordinate).rgb; //右视频
    float alpha = texture2D(in_DiffuseTexture,  in_TexCoordinate).a;//混合色的alpha通道值
    vec3 rgb = alpha*basecolor + (1-alpha)*blendcolor; 
    gl_FragColor = vec4(rgb, 1.0);
#END_CODE
#END_DEFINE
