//////////////////////////////////////////////////////////////////////////////////////
//
//						The Bohge Engine License (BEL)
//
//	Copyright (c) 2011-2014 Peng Zhao
//
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:
//
//	The above copyright notice and this permission notice shall be included in 
//	all copies or substantial portions of the Software. And the logo of 
//	Bohge Engine shall be displayed full screen for more than 3 seconds 
//	when the software is started. Copyright holders are allowed to develop 
//	game edit based on Bohge Engine, The edit must be released under the MIT 
//	open source license if it is going to be published. In no event shall 
//	copyright holders be prohibited from using any code of Bohge Engine 
//	to develop any other analogous game engines.
//
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//
//////////////////////////////////////////////////////////////////////////////////////





#SHADER_DEFINE EmitterBaseUV

	FUNCTION_INPUT = 
	{
		{ ATTRIBUTE_COORDNATE0,		MEDIUM,	VEC2,		"in_Coord_Index" },
	}
	FUNCTION_OUTPUT = 
	{
		{ ATTRIBUTE_COORDNATE0,		MEDIUM,	VEC2,		"out_Coordinate" },
	}

#SHADER_CODE
    vec2 out_Coordinate = in_Coord_Index;
#END_CODE
#END_DEFINE

#SHADER_DEFINE EmitterAtlasAnimationUV

	FUNCTION_INPUT = 
	{
		{ ATTRIBUTE_COORDNATE0,		MEDIUM,	VEC2,		"in_Coord_Index" },
		{ ATTRIBUTE_BINORMAL, 	MEDIUM, VEC3, "in_Tiles_Frame"},
	}
	FUNCTION_OUTPUT = 
	{
		{ ATTRIBUTE_COORDNATE0,		MEDIUM,	VEC2,		"out_Coordinate" },
	}

#SHADER_CODE
    int indexV = int(in_Tiles_Frame.z) / int(in_Tiles_Frame.x);
    int indexU = int(in_Tiles_Frame.z) - indexV * int(in_Tiles_Frame.x);
    float coordU = float(indexU) / in_Tiles_Frame.x;
    float coordV = float(indexV) / in_Tiles_Frame.y;
    float deltaU = 1.0 / in_Tiles_Frame.x;
    float deltaV = 1.0 / in_Tiles_Frame.y;
    vec2 out_Coordinate = vec2(coordU,coordV);
    out_Coordinate.x += (in_Coord_Index.x * deltaU);
    out_Coordinate.y += (in_Coord_Index.y * deltaV);
#END_CODE
#END_DEFINE