
function DefineParams()
	Properties = 
	{
		
_MainTex = { "main Color", TEXTURE2D, "maintex" },
_DistortCenter = { "distortiont center", VEC2, "0.5, 0.5"},
_Convergence = { "convergence", FLOAT, "1.0" },

POST_EFFECT_ALPHA = {"post_effect_alpha", FLOAT, "0.0"},

	}
	Attributes = 
	{
		POST_EFFECT_ALPHA = "Keywords(POST_EFFECT_ALPHA_ON,POST_EFFECT_ALPHA_OFF)", 
	}
	
end



function Init()
	PassNames = 
	{
		"Always"
	}

ShaderName = "CCLens"
RenderQueue = "PostEffect"
end

function Always()

COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_OFF }
DRAW_MODE = { CULL_FACE_OFF, DEPTH_MASK_ON, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }


Programs =
{
	{
		shaderApi = "gles2",
		keyWords = {"POST_EFFECT_ALPHA_ON"},
		vsBufferSize = "0",
		vsAttributes = {
		},
		vsUniforms = {
			{
				varName = "DEVICE_COORDINATE_Y_FLIP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		psBufferSize = "0",
		psUniforms = {
			{
				varName = "_MainTex",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "_Radius",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "_DistortCenter",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "_Convergence",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		vsShader = [===[attribute vec4 _glesVertex;
attribute vec4 _glesMultiTexCoord0;
uniform highp float DEVICE_COORDINATE_Y_FLIP;
varying highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.xzw = vec3(1.0, 1.0, 1.0);
  tmpvar_1.y = DEVICE_COORDINATE_Y_FLIP;
  xlv_TEXCOORD0 = _glesMultiTexCoord0.xy;
  gl_Position = (tmpvar_1 * _glesVertex);
}

]===],
		psShader = [===[uniform sampler2D _MainTex;
uniform highp vec2 _Radius;
uniform highp vec2 _DistortCenter;
uniform highp float _Convergence;
varying highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 c_2;
  highp vec2 uv_3;
  highp float tmpvar_4;
  tmpvar_4 = clamp (_Convergence, -1.0, 2.0);
  highp vec2 tmpvar_5;
  tmpvar_5 = ((xlv_TEXCOORD0 - _DistortCenter) / _Radius);
  uv_3 = tmpvar_5;
  highp float tmpvar_6;
  tmpvar_6 = dot (tmpvar_5, tmpvar_5);
  if (((tmpvar_6 > 1.0) && (tmpvar_4 < 0.0))) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 1.0);
  } else {
    uv_3 = (((tmpvar_5 * 
      (1.0 + (tmpvar_4 * ((tmpvar_5.x * tmpvar_5.x) + (tmpvar_5.y * tmpvar_5.y))))
    ) * _Radius) + _DistortCenter);
    highp vec2 tmpvar_7;
    tmpvar_7 = (1.0 - vec2(greaterThanEqual (
      abs(((uv_3 * 2.0) - 1.0))
    , vec2(1.0, 1.0))));
    lowp vec4 tmpvar_8;
    tmpvar_8 = texture2D (_MainTex, uv_3);
    c_2 = tmpvar_8;
    c_2.xyz = (c_2.xyz * (tmpvar_7.x * tmpvar_7.y));
    tmpvar_1 = c_2;
  };
  gl_FragData[0] = tmpvar_1;
}

]===],
	},
	{
		shaderApi = "gles2",
		keyWords = {"POST_EFFECT_ALPHA_OFF"},
		vsBufferSize = "0",
		vsAttributes = {
		},
		vsUniforms = {
			{
				varName = "DEVICE_COORDINATE_Y_FLIP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		psBufferSize = "0",
		psUniforms = {
			{
				varName = "_MainTex",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "_Radius",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "_DistortCenter",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "_Convergence",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		vsShader = [===[attribute vec4 _glesVertex;
attribute vec4 _glesMultiTexCoord0;
uniform highp float DEVICE_COORDINATE_Y_FLIP;
varying highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.xzw = vec3(1.0, 1.0, 1.0);
  tmpvar_1.y = DEVICE_COORDINATE_Y_FLIP;
  xlv_TEXCOORD0 = _glesMultiTexCoord0.xy;
  gl_Position = (tmpvar_1 * _glesVertex);
}

]===],
		psShader = [===[uniform sampler2D _MainTex;
uniform highp vec2 _Radius;
uniform highp vec2 _DistortCenter;
uniform highp float _Convergence;
varying highp vec2 xlv_TEXCOORD0;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec3 c_2;
  highp vec2 uv_3;
  highp float tmpvar_4;
  tmpvar_4 = clamp (_Convergence, -1.0, 2.0);
  highp vec2 tmpvar_5;
  tmpvar_5 = ((xlv_TEXCOORD0 - _DistortCenter) / _Radius);
  uv_3 = tmpvar_5;
  highp float tmpvar_6;
  tmpvar_6 = dot (tmpvar_5, tmpvar_5);
  if (((tmpvar_6 > 1.0) && (tmpvar_4 < 0.0))) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 1.0);
  } else {
    uv_3 = (((tmpvar_5 * 
      (1.0 + (tmpvar_4 * ((tmpvar_5.x * tmpvar_5.x) + (tmpvar_5.y * tmpvar_5.y))))
    ) * _Radius) + _DistortCenter);
    highp vec2 tmpvar_7;
    tmpvar_7 = (1.0 - vec2(greaterThanEqual (
      abs(((uv_3 * 2.0) - 1.0))
    , vec2(1.0, 1.0))));
    lowp vec3 tmpvar_8;
    tmpvar_8 = texture2D (_MainTex, uv_3).xyz;
    c_2 = tmpvar_8;
    c_2 = (c_2 * (tmpvar_7.x * tmpvar_7.y));
    highp vec4 tmpvar_9;
    tmpvar_9.w = 1.0;
    tmpvar_9.xyz = c_2;
    tmpvar_1 = tmpvar_9;
  };
  gl_FragData[0] = tmpvar_1;
}

]===],
	},
}

end
