function DefineParams()
	Properties = 
	{
		
CURL        = {"CURL", TEXTURE2D, "CURL"},
VELOCITY    = {"VELOCITY", TEXTURE2D, "VELOCITY"},
TEXEL_SIZE  = {"TEXEL_SIZE", VEC2, "64.0, 64.0"},
CURL_CONFIG = {"CURL_CONFIG", FLOAT, "30.0"},
TIME_STEP   = {"TIME_STEP", FLOAT, "0.01"},
FLOAT_MIN   = {"FLOAT_MIN", FLOAT, "-100.0"},
FLOAT_MAX   = {"FLOAT_MAX", FLOAT, "100.0"},

	}
	Attributes = 
	{
	}
	
end



function Init()
	PassNames = 
	{
		"Always"
	}

ShaderName  = "VorticityStep"
RenderQueue = "PostEffect"
end

function Always()

COLOR_MASK   = COLOR_RGBA
ALPAH_MODE   = { ALPAH_OFF }
DRAW_MODE    = { CULL_FACE_OFF, DEPTH_MASK_OFF, DEPTH_TEST_OFF }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE   = { ALWAYS }


Programs =
{
	{
		shaderApi = "gles3",
		keyWords = {},
		vsBufferSize = "0",
		vsAttributes = {
		},
		vsUniforms = {
			{
				varName = "DEVICE_COORDINATE_Y_FLIP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "TEXEL_SIZE",
				varType = "float2",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		psBufferSize = "0",
		psUniforms = {
			{
				varName = "CURL",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "VELOCITY",
				varType = "sampler2D",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "CURL_CONFIG",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "TIME_STEP",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "FLOAT_MIN",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			{
				varName = "FLOAT_MAX",
				varType = "float",
				varSit = "",
				varNum = "1",
				varRegIndex = "0",
				varRegCount = "1",
			},
			},
		vsShader = [===[#version 300 es
in vec4 _glesVertex;
in vec4 _glesMultiTexCoord0;
uniform highp float DEVICE_COORDINATE_Y_FLIP;
uniform highp vec2 TEXEL_SIZE;
out highp vec2 xlv_TEXCOORD0;
out highp vec2 xlv_TEXCOORD1;
out highp vec2 xlv_TEXCOORD2;
out highp vec2 xlv_TEXCOORD3;
out highp vec2 xlv_TEXCOORD4;
void main ()
{
  highp vec4 tmpvar_1;
  tmpvar_1.xzw = vec3(1.0, 1.0, 1.0);
  tmpvar_1.y = DEVICE_COORDINATE_Y_FLIP;
  highp vec2 tmpvar_2;
  tmpvar_2.y = 0.0;
  tmpvar_2.x = TEXEL_SIZE.x;
  highp vec2 tmpvar_3;
  tmpvar_3.y = 0.0;
  tmpvar_3.x = TEXEL_SIZE.x;
  highp vec2 tmpvar_4;
  tmpvar_4.x = 0.0;
  tmpvar_4.y = TEXEL_SIZE.y;
  highp vec2 tmpvar_5;
  tmpvar_5.x = 0.0;
  tmpvar_5.y = TEXEL_SIZE.y;
  xlv_TEXCOORD0 = _glesMultiTexCoord0.xy;
  xlv_TEXCOORD1 = (_glesMultiTexCoord0.xy - tmpvar_2);
  xlv_TEXCOORD2 = (_glesMultiTexCoord0.xy + tmpvar_3);
  xlv_TEXCOORD3 = (_glesMultiTexCoord0.xy + tmpvar_4);
  xlv_TEXCOORD4 = (_glesMultiTexCoord0.xy - tmpvar_5);
  gl_Position = (tmpvar_1 * _glesVertex);
}

]===],
		psShader = [===[#version 300 es
layout(location=0) out mediump vec4 _glesFragData[1];
uniform sampler2D CURL;
uniform sampler2D VELOCITY;
uniform highp float CURL_CONFIG;
uniform highp float TIME_STEP;
uniform highp float FLOAT_MIN;
uniform highp float FLOAT_MAX;
in highp vec2 xlv_TEXCOORD0;
in highp vec2 xlv_TEXCOORD1;
in highp vec2 xlv_TEXCOORD2;
in highp vec2 xlv_TEXCOORD3;
in highp vec2 xlv_TEXCOORD4;
void main ()
{
  highp vec2 vel_1;
  highp vec2 force_2;
  highp float tmpvar_3;
  tmpvar_3 = (FLOAT_MAX - FLOAT_MIN);
  lowp vec4 tmpvar_4;
  tmpvar_4 = texture (CURL, xlv_TEXCOORD0);
  lowp vec4 tmpvar_5;
  tmpvar_5 = texture (CURL, xlv_TEXCOORD1);
  lowp vec4 tmpvar_6;
  tmpvar_6 = texture (CURL, xlv_TEXCOORD2);
  lowp vec4 tmpvar_7;
  tmpvar_7 = texture (CURL, xlv_TEXCOORD3);
  lowp vec4 tmpvar_8;
  tmpvar_8 = texture (CURL, xlv_TEXCOORD4);
  highp vec2 tmpvar_9;
  tmpvar_9.x = (abs((
    (tmpvar_7.x * tmpvar_3)
   + FLOAT_MIN)) - abs((
    (tmpvar_8.x * tmpvar_3)
   + FLOAT_MIN)));
  tmpvar_9.y = (abs((
    (tmpvar_6.x * tmpvar_3)
   + FLOAT_MIN)) - abs((
    (tmpvar_5.x * tmpvar_3)
   + FLOAT_MIN)));
  highp vec2 tmpvar_10;
  tmpvar_10 = (0.5 * tmpvar_9);
  force_2 = (tmpvar_10 / (sqrt(
    dot (tmpvar_10, tmpvar_10)
  ) + 0.0001));
  force_2 = (force_2 * (CURL_CONFIG * (
    (tmpvar_4.x * tmpvar_3)
   + FLOAT_MIN)));
  force_2.y = -(force_2.y);
  lowp vec4 tmpvar_11;
  tmpvar_11 = texture (VELOCITY, xlv_TEXCOORD0);
  vel_1 = (((tmpvar_11.xy * tmpvar_3) + FLOAT_MIN) + (force_2 * TIME_STEP));
  vel_1 = ((vel_1 - vec2(FLOAT_MIN)) / tmpvar_3);
  highp vec4 tmpvar_12;
  tmpvar_12.zw = vec2(0.0, 1.0);
  tmpvar_12.xy = vel_1;
  _glesFragData[0] = tmpvar_12;
}

]===],
	},
}

end