#DEFPARAMS
_MainTex = {"MainTex", TEXTURE2D, "white" },
_MainCol = {"MainCol", COLOR, "1.0,1.0,1.0,1.0"},
#END

#DEFTAG
ShaderName = "nl_transparent"
RenderQueue = "Transparent"
#END

#DEFPASS Always
COLOR_MASK = COLOR_RGBA
ALPAH_MODE = { ALPAH_BLEND, SRC_ALPHA, ONE_MINUS_SRC_ALPHA, ONE, ONE }
DRAW_MODE = { CULL_FACE_BACK, DEPTH_MASK_OFF, DEPTH_TEST_ON, DEPTH_FUNCTION_LESS }
STENCIL_MODE = { STENCIL_OFF }
LIGHT_MODE = { ALWAYS }

CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#include "light.inc"
#include "common.inc"

struct appdata
{
	float4 vertex : POSITION;
	float2 uv : TEXCOORD0;
};

struct v2f
{
	float2 uv     : TEXCOORD0;
	float4 vertex : SV_POSITION;
};

sampler2D _MainTex;
float4 _MainCol;


v2f vert(appdata v)
{
	v2f o;
	float4 pos = v.vertex * (1.0 / v.vertex.w);
	pos = mul(LOCALWORLD_TRANSFORM, pos);
	pos.w = 1.0;
	pos.x = pos.x + WORLD_POSITION.x;
	pos.y = pos.y + WORLD_POSITION.y;
	o.vertex = UniformNDC(pos);
	o.uv = v.uv.xy;
	return o;
}

float4 frag(v2f i) : SV_Target
{	
    fixed4 frameColor  = tex2D(_MainTex, i.uv);
    frameColor = frameColor*_MainCol;
    return frameColor;
}
ENDCG
#END
