--local apolloengine = require "apolloengine"
local cv = require "computervisionfunction"
local utility = require "utility"
local DeviceResource = require "apolloengine.deviceresource"
local apollocore = require "apollocore"
local venuscore = require "venuscore"
local mathfunction = require "mathfunction"



function findTableKey(t,key)
  for k,v in pairs(t) do
    if k == key then
      return true
    end
  end
  return false
end

local fNativeUpdate = cv.AIFaceTransferComponent.Update;
local fNativeStart = cv.AIFaceTransferComponent.Start;

local StartFoo = function(self)
  local tex2 = self:GetSrcResult();
  local tex = self:GetStyleResult();
  DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK,
    tex2);
  DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER,
    tex);
  fNativeStart(self);
end

local UpdateFoo = function (self,dt)
  if not self:isStarted() then
    self:Start();
  end

  local reslist = DeviceResource.ResourceList["TextureEntity"];
  if (self.Type == cv.AIFaceTransferComponent.cvAIFace1 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri1) and not findTableKey(reslist,"OLD_FACE")  then

    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK1,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER1,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace2 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri2) and not findTableKey(reslist,"KID_FACE") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK2,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER2,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace3 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri3) and  not findTableKey(reslist,"FEMALE_BEAUTY_FACE") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK3,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER3,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace4 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri4) and not  findTableKey(reslist,"MALE_BEAUTY_FACE") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK4,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER4,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace5 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri5) and  not findTableKey(reslist,"CG_FACE") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK5,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER5,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace6 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri6) and  not findTableKey(reslist,"BALD_FACE") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK6,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER6,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace7 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri7) and not findTableKey(reslist,"AIFACE_STYLE7") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK7,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER7,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace8 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri8) and not findTableKey(reslist,"AIFACE_STYLE8") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK8,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER8,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace9 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri9) and not findTableKey(reslist,"AIFACE_STYLE9") then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK9,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER9,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace10 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri10) and not findTableKey(reslist,"AIFACE_STYLE10")  then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK10,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER10,
    tex);  


  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace11 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri11) and not findTableKey(reslist,"AIFACE_STYLE11")  then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK11,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER11,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace12 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri12) and not findTableKey(reslist,"AIFACE_STYLE12")  then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK12,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER12,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace13 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri13) and not findTableKey(reslist,"AIFACE_STYLE13")  then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK13,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER13,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace14 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri14) and not findTableKey(reslist,"AIFACE_STYLE14")  then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK14,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER14,
    tex);  

  elseif (self.Type == cv.AIFaceTransferComponent.cvAIFace15 or self.Type == cv.AIFaceTransferComponent.cvAIFaceOri15) and not findTableKey(reslist,"AIFACE_STYLE15")  then
    local tex2 = self:GetSrcResult();
    local tex = self:GetStyleResult();
    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFERBK15,
      tex2);  

    DeviceResource:PushDeviceResource(
    DeviceResource.DEVICE_AIFACETRANSFER15,
    tex);  
  else
    LOG("No aiface type");
  end
    
  fNativeUpdate(self, dt);

end

--此处必须用rawset，否则会把UPDATE函数设置到cv.StyleTransferComponent的元表的UPDATE中。
rawset(cv.AIFaceTransferComponent,"Update", UpdateFoo)
rawset(cv.AIFaceTransferComponent,"Start", StartFoo)

