
local ae = require "apolloengine"
local mf = require "mathfunction"

local findedge = {}

function findedge:Initialize(host, size)

  self.renderObject = nil
  self.Queue = 100
 
  self.IMAGE_SIZE = ae.IMaterialSystem:NewParameterSlot(
    ae.ShaderEntity.UNIFORM,
    "ImageSize")

  self.POST_EFFECT_ALPHA = ae.IMaterialSystem:NewParameterSlot(
    ae.ShaderEntity.UNIFORM,
    "POST_EFFECT_ALPHA");

  self.renderObject = host:CreateRenderObject("comm:documents/shaders/posteffect/findedge.material");
  self.renderObject:SetParameter(self.POST_EFFECT_ALPHA, mf.vector1(1.0));
  
  self.renderObject:SetParameter(self.IMAGE_SIZE, size);
  
  return self.Queue
end

function findedge:Resizeview(size)
  self.renderObject:SetParameter(self.IMAGE_SIZE, size);
end

function findedge:Process(pipeline, Original, Scene, Output)
  Output:PushRenderTarget()
  Output:ClearBuffer(ae.RenderTargetEntity.CF_COLOR)

  local materials = self.renderObject.MaterialEntities;
  local material = materials[1];
    
  material:SetParameter(
    "_MainTex",
    Scene:GetAttachment(ae.RenderTargetEntity.TA_COLOR_0));
  
  self.renderObject:Draw(pipeline)
end


return findedge;